local mod = RW:Boss("Magmaw", "Blackwing Descent")
local L

mod.BossIcon = [[Interface\ICONS\ability_hunter_pet_worm]]

---------------------------
-- Variables

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(41570)
	self:SetWin()
	
	-- Pillar of Flame 78006
    self:RegisterAlert("wPoF", self:CastWarning(78006))
    self:RegisterAlert("tPoFCD", self:CDTimer(35, 78006))
	
	-- Mangle
	self:RegisterAlert("tMangleCD", self:CDTimer(95, 91912))
	self:RegisterAlert("tMangleDur", self:DurTargetTimer(30, 91912))
	self:RegisterAlert("wMangle", self:CastWarning(91912))
	
	-- Parasitic Infection
	self:RegisterAlert("wInfection", self:RunawayWarning(94679))
	self:RegisterAlert("iInfection", self:Icon("SKULL", 94679, false, 10, "TRIANGLE", "SQUARE", "DIAMOND"))
	self:RegisterAlert("mInfection", self:TargetMessage(94679))
	
	-- Blazing Inferno (Heroic)
	self:RegisterAlert("wBlaze", self:CastWarning(92191))
	self:RegisterAlert("tBlazeCD", self:CDTimer(35, 92191))
	
	-- Molten Tantrum 78403
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("PoF", 78006)
	self:Track("Mangle", 91912)
	self:Track("Infection", 94679, 78097, 78941, 91913, 94678)
	
	-- Heroic
	self:Track("Blaze", 92191, 92192, 92190, 92154)
	
	if self:IsHeroic() then
		self:Call("tBlazeCD", "Start", 20)
	end
end

function mod:PoF(event, args)
    if event == "SPELL_AURA_APPLIED" then
        self:Call("wPoF", "Show")
        self:Call("tPoFCD", "Start")		
    end
end

function mod:Mangle(event, args)
	if event == "SPELL_AURA_APPLIED" then
		self:Call("tMangleCD", "Start")
		self:Call("tMangleDur", "Start", args.dName)
		self:Call("wMangle", "Show")
	end
end

function mod:Infection(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			self:Call("wInfection", "Show")
			RW.Callbacks:Fire("RangeCheckShow", true, 8)
		end
		
		self:Call("mInfection", "AddDelayTarget", args.dName)
		self:Call("mInfection", "DelayedShow", 0.3)
		self:Call("iInfection", "Show", args.dName)
	
	elseif event == "SPELL_AURA_REMOVED" then
		if args:IsPlayer() then
			RW.Callbacks:Fire("RangeCheckHide")
		end
		
		self:Call("iInfection", "Hide", args.dName)
	end
end

function mod:Blaze(event, args)
	if event == "SPELL_SUMMON" then
		self:Call("wBlaze", "Show")
		self:Call("tBlazeCD", "Start")
	end
end
