local mod = RW:Boss("Nefarian", "Blackwing Descent")
local L

mod.BossIcon = [[Interface\ICONS\achievement_dungeon_blackwingdescent_raid_nefarian]]

---------------------------
-- Variables

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L["Phase 2 Emote"] = "Curse you, mortals! Such a callous disregard for one's possessions must be met with extreme force!"
		
		L["Phase Change"] = "Phase Change"
		
		L["Electrocute Emote"] = "The air crackles with electricity!"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(41376, 41270) -- Nefarian, Onyxia
	self:SetWin()
	
	self:RegisterAlert("mPhase", self:PhaseMessage())
	
	self:RegisterAlert("tPhaseChange", self:CustomTimer(180, L["Phase Change"], L["Phase Change"], [[Interface\Icons\Achievement_BG_killingblow_30]]))
	
	-- Electrocute
	self:RegisterAlert("wElectrocute", self:CastWarning(94088))
	self:RegisterAlert("tElectrocute", self:CastTimer(5, 94088))
	
	-- Cinders
	self:RegisterAlert("iCinders", self:Icon("STAR", 79339, false, 8, "CIRCLE", "TRIANGLE"))
	self:RegisterAlert("mCinders", self:TargetMessage(79339))
	self:RegisterAlert("tCindersDur", self:DurTimer(8, 79339))
	self:RegisterAlert("wCinders", self:RunawayWarning(79339))
end

---------------------------
-- Locals
local CromaticID = 41948
local CromaticAlive = 3

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Electrocute", 94088, 82172, 94089, 94090)
	self:Track("Cinder", 79339)

	self:YellTrack("Phase2", L["Phase 2 Emote"])
	self:YellTrack("ElectrocuteEmote", L["Electrocute Emote"])
	
	RW.Callbacks:Fire("MPBPowerByID", 41270, "Default", nil, nil, true)
	
	CromaticAlive = 3
end

function mod:Electrocute(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		
	end
end

function mod:UNIT_DIED(cID, gUID)
	if cID == CromaticID then
		CromaticAlive = CromaticAlive - 1
		if CromaticAlive == 0 then
			self:Call("mPhase", "Show", 3)
		end
	end
end

function mod:Phase2(event, msg, name)
	self:Call("mPhase", "Show", 2)
	self:Call("tPhaseChange", "Start")
	RW.Callbacks:Fire("MPBPowerHideByID", 41270)
end

function mod:ElectrocuteEmote(event, msg, name)
	self:Call("wElectrocute", "Show")
	self:Call("tElectrocute", "Start")
end

function mod:Cinder(event, args)
	if event == "SPELL_AURA_APPLIED" then
		self:Call("iCinders", "Show", args.dName)
		self:Call("mCinders", "AddDelayTarget", args.dName)
		self:Call("mCinders", "DelayedShow", 0.2)
		self:Call("tCindersDur", "Start")
		
		if args:IsPlayer() then
			self:Call("wCinders", "Show")
		end
	end
end

